



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用反射模拟一个spring的内部工作原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用反射模拟一个spring的内部工作原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 07:16:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<pre class="prettyprint linenums">

这个简单的案例是实行了登录和注册的功能，没有链接数据库。<br />
&nbsp;在bean中id 是唯一的，id和name的区别在于id不能用特殊字符而name可以用特殊字符，比如：/-\....
</pre>
<div>
<div>
<pre class="prettyprint linenums"> package com.obtk.reflect;

 public class Logon {<br />
     /**<br />
      * 帐号密码长度大于六位字符就成功,否则失败！<br />
      * */<br />
     public String select(String name, String pass) {<br />
         if (name.length() &gt; 6 &amp;&amp; pass.length() &gt; 6) {<br />
             return name + "用户，恭喜你注册成功";<br />
         }<br />
         return name + "用户，注册失败，密码长度或者帐号长度不对！";<br />
     }

     /**<br />
      * 帐号密码长度大于六位字符就成功,否则失败！<br />
      * */<br />
     public String get(String name, String pass) {<br />
         if (name.length() &gt; 6 &amp;&amp; pass.length() &gt; 6) {<br />
             return name + "用户，恭喜你登录成功";<br />
         }<br />
         return name + "用户，登录失败，密码和帐号不匹配！";<br />
     }<br />
 }</pre>
</div>
<p>Logon.java 实体类代码</p></div>
<div>
<div>
<pre class="prettyprint linenums"> package com.obtk.reflect;

 import java.io.InputStream;<br />
 import java.util.HashMap;<br />
 import java.util.Iterator;<br />
 import java.util.Map;<br />
 import org.dom4j.Document;<br />
 import org.dom4j.Element;<br />
 import org.dom4j.io.SAXReader;

 public class LogonReflect {

     private Map&lt;String, Object&gt; beans = new HashMap&lt;String, Object&gt;();

     /**<br />
      * 解析xml文档<br />
      * */<br />
     public LogonReflect(String xmlFile) {<br />
         try {<br />
             // 获取xm文档解析<br />
             SAXReader reader = new SAXReader();<br />
             // 获取加载器<br />
             ClassLoader loader = Thread.currentThread().getContextClassLoader();<br />
             // classes文件夹读取配置文件<br />
             InputStream is = loader.getResourceAsStream(xmlFile);<br />
             // 从文件流读取数据构建xml文档对象<br />
             Document doc = reader.read(is);<br />
             // 获取xml的根节点(beans)<br />
             Element root = doc.getRootElement();<br />
             // 获取根节点所有的子节点(bean)<br />
             Iterator&lt;Element&gt; beanEI = root.elementIterator("bean");<br />
             // 循环所有的子节点<br />
             while (beanEI.hasNext()) {<br />
                 // 获取本次循环的子节点<br />
                 Element eBean = beanEI.next();<br />
                 // 获取bean节点的id的文本内容<br />
                 String id = eBean.attribute("id").getText();<br />
                 // 获取bean节点的class的文本内容<br />
                 String className = eBean.attribute("class").getText();<br />
                 // 第一个个 参数座位id，第二个参数做为一个类的实例化对象<br />
                 beans.put(id, Class.forName(className).newInstance());<br />
             }

         } catch (Exception e) {<br />
             e.printStackTrace();<br />
         }<br />
     }

     /**<br />
      * 根据id获取所对的对象<br />
      * */<br />
     public Object getBean(String beanName) {<br />
         return beans.get(beanName);<br />
     }<br />
 }</pre>
</div>
<p>LogonReflect.java 实体类代码</p></div>
<div>
<div>
<pre class="prettyprint linenums"> package com.obtk.reflect;

 public class LogonTest {<br />
     public static void main(String[] args) {<br />
         //传一个xml路径，<br />
         LogonReflect lReflect = new LogonReflect("Logon.xml");<br />
         //根据id去xml中获取实体类，默认是Object类型的，所以要强制转换<br />
         Logon logon = (Logon) lReflect.getBean("logon");<br />
         //获取对象任何就直接调用方法<br />
         System.out.println(logon.get("123456789", "987654321"));<br />
         System.out.println(logon.select("qqqqqqq", "qqqqqqq"));<br />
     }<br />
 }</pre>
</div>
<p>测试类的代码</p></div>
<div>
<div>
<pre class="prettyprint linenums"> &lt;beans&gt;<br />
     &lt;bean id="logon" class="com.obtk.reflect.Logon" /&gt;<br />
 &lt;/beans&gt;</pre>
</div>
<p>beans.xml 配置xml</p></div>
<ol><li><p><strong>Reflection的意思是&ldquo;反射、映象、倒影&rdquo;，用在Java身上指的是我们可以于运行时加载、探知、使用编译期间完全未知的classes。换句话说，Java程序可以加载一个运行时才得知名称的class，获悉其完整构造（但不包括methods定义），并生成其对象实体、或对其fields设值、或唤起(调用)其methods。这种&ldquo;看透class&rdquo;的能力（the ability of the program to examine itself）被称为introspection</strong></p></li>
<li><p>在Java运行时环境中，对于任意一个类，能否知道这个类有哪些属性和方法？对于任意一个对象，能否调用它的任意一个方法？答案是肯定的。这种动态获取类的信息，以及动态调用对象的方法的功能来自于Java语言的反射（Reflection）机制。Java反射机制主要提供了以下功能：</p></li></ol>
<ul><li><p><strong>在运行时判断任意一个对象所属的类；</strong></p></li>
<li><p><strong>在运行时构造任意一个类的对象；</strong></p></li>
<li><p><strong>在运行时判断任意一个类所具有的成员变量和方法；</strong></p></li>
<li><p><strong>在运行时调用任意一个对象的方法；</strong></p></li>
<li><p><strong>生成动态代理。</strong></p></li>
<li><table>
<tbody>
<tr>
<td>
<p>文件名</p>
</td>
<td>
<p>说 明</p>
</td>
</tr>
<tr>
<td>
<p>getFields()<br />getDeclaredFields()<br />getField(String name)<br />getMethods()<br />getMethod (String name，Class [] args)<br />getConstrutors()<br />getConstrutor(Class[] args)<br />newInstance()<br />getName()<br />getPackage()<br />getSuperclass()</p>
</td>
<td>
<p>获得类的public类型的属性。<br />获得类的所有属性 <br />获得类的指定属性<br />获得类的public类型的方法<br />获得类的指定方法<br />获得类的public类型的构造方法<br />获得类的特定构造方法<br />通过类的无参构造方法创建该类的一个对象<br />获得类的完整名字<br />获取此类所属的包<br />获得此类的父类对应的Class对象</p>
</td>
</tr>
</tbody>
</table></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1g279.html">Linux 下  ---ThinkPHP 图片上传提示：上传根目录不存在！请尝试手动创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2mv438.html">&lbrack;SublimeText&rsqb; 安装包管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx3o3vq.html">Reactjs 入门基础&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g7y2e9.html">mac下java 开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ozlo9.html">POJ1947 Rebuilding Roads</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1gnd39.html">shell脚本判断文件类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vd6x48.html">BZOJ 3083 - 遥远的国度</a>
		</li>
						<li><a href="https://www.batexi.com/a/qderkyx9.html">UVa 1599 &lpar;字典序最小的最短路&rpar; Ideal Path</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1oxv38.html">HTML&amp;amp&semi;CSS基础学习笔记1&period;26-input重置表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1pvej8.html">&lbrack;Regular Expressions&rsqb; Introduction</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpp7k69.html">ThreadLocal的内存泄露（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kp6109.html">oracle求时间差的常用函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0jpo8.html">git合并别的分支某次提交或合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zg45g9.html">Spring&plus;TaskExecutor实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo3plxq.html">设计模式笔记&mdash;&mdash;GoF设计模式汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jlk3l8.html">Javascript和BHO的相互调用简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z57gx9.html">setUp&lpar;&rpar;和tearDown&lpar;&rpar;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojm1olq.html">【easy-】437&period; Path Sum III 二叉树任意起始区间和</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdm53z9.html">ResourceBundle与Properties读取配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllg1n0q.html">&lbrack;Shell&rsqb;Bash基本功能：输入输出重定向</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49gdej09.html">php &colon; 常用函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zjkox9.html">JS获取元素尺寸大小、鼠标位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r04ye9.html">转：OSGi 入门篇：模块层</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdoorj8.html">iOS中的数据持久化方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ndyk9.html">js 根据不同情况引入不同操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn5wpkq.html">HTML 或 CSS 文件中引用的图片文件移动到任意位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyr60x8.html">奇淫绝技：Mysql报错注入利用总结分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1jydzq.html">分枝定界的matlab实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o53oe9.html">jquery 源码解析  节点遍历</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdog1j8.html">ERROR 2002 &lpar;HY000&rpar;&colon; Can&amp;&num;39&semi;t connect to local MySQL server through socket &amp;&num;39&semi;&sol;var&sol;lib&sol;mysql&sol;mysql&period;sock&amp;&num;39&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
